#!/usr/bin/python
# -*- coding: utf-8 -*-

# PyStnAPID (set APID in PyStation.cfg)
# SYMBIAN_UID = 0xe70f9c14
# masa
# (c) 2014 masa
__script__  = "PyStnAPID"
__version__ = "0.01(1)"
__copy__    = "masa"
__web__     = "http://masaland.cocolog-nifty.com/"

import sys, os
#sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import e32
import os.path
import socket
import appuifw, globalui

try:
    import ConfigParser
except:
    appuifw.note(unicode('ConfigParserモジュールが見つかりません。','UTF-8'), 'error')
    raise

lock = e32.Ao_lock()

class ConfigError(Exception):
    """設定エラー"""
    def __init__(self):
        pass
    def __str__(self):
        return repr(u'Configuration is incomplete.')


# データフォルダ
DATA_PATH = u'E:\\Data\\Hiisi\\PyStation'
# 設定ファイル
CFG_FILE = os.path.join(DATA_PATH, u'PyStation.cfg')


# データフォルダ、設定ファイルパス
def make_cfg_path():
    global DATA_PATH, CFG_FILE
    if not os.path.exists(DATA_PATH):
        DATA_PATH = u'C:\\Data\\Hiisi\\PyStation'
        if not os.path.isdir(DATA_PATH):
            # データ保存に利用するドライブを選択
            drives = []
            if u'C:' in e32.drive_list():
                drives.append(u'C:\\Data\\Hiisi\\PyStation')
            if u'E:' in e32.drive_list():
                drives.append(u'E:\\Data\\Hiisi\\PyStation')
            drive = appuifw.popup_menu(drives,
                                   unicode('設定データ保存場所'))
            if drive == 0:
                DATA_PATH = u'C:\\Data\\Hiisi\\PyStation'
            elif drive == 1:
                DATA_PATH = u'E:\\Data\\Hiisi\\PyStation'
            else:
                appuifw.note(unicode('設定ファイルを作成できません。'), 'error')
                raise ConfigError
            try:
                os.makedirs(DATA_PATH)
            except OSError:
                appuifw.note(unicode('設定ファイルを作成できません。'), 'error')
                raise
    # 設定ファイル
    CFG_FILE = os.path.join(DATA_PATH, u'PyStation.cfg')


def get_apid():
    try:
        aps = socket.access_points()
    except:
        appuifw.note(unicode('apidが取得できません。','UTF-8'), 'error', 1)
        raise ConfigError
    aplist = []
    apdic = {}
    for ap in aps:
        id = ap['iapid']
        iname = ap['name']
        apdic.update({id : iname})
    apkeys = (apdic.keys())
    apkeys.sort()
    for apk in apkeys:
        aplist.append('%4d : %s' % (apk, apdic[apk]))
    idx = appuifw.popup_menu(aplist, u'APID List')
    if idx == None:
        APID = None
    else:
        APID = apkeys[idx]
    e32.ao_yield() # 画面反映
    return idx, APID


def set_cfg_apid():
    global CFG_FILE
    if os.path.isfile(CFG_FILE):
        cfg = ConfigParser.ConfigParser()
        cfg.read(CFG_FILE)

        try:
            APID = int(cfg.get('PyStation', 'APID')) #check exist (section, option)
        except (ConfigParser.NoSectionError):
            cfg.add_section('PyStation')
        except (ConfigParser.NoOptionError):
            pass
        except:
            raise
    else:
        cfg = ConfigParser.ConfigParser()
        cfg.add_section('PyStation')

    #get apid then set it into PyStation.cfg
    idx, APID = get_apid()
    if idx == None:
        appuifw.note(unicode('キャンセルされました。', 'UTF-8') , 'info', 1)
    else:
        cfg.set('PyStation', 'APID', APID)
        try:
            f = open(CFG_FILE, 'w')
            cfg.write(f)
            f.close()
        except:
            raise

        msg = 'APIDを書きかえました。\nAPID %s\n終了します。' % str(APID)
        globalui.global_msg_query(unicode(msg, "utf-8"), unicode("結果", "utf-8"))
        #終了させる
        appExit()


def do_dummy():
    pass


def appExit():
    lock.signal()


def main():
    """メインの関数"""
    list_wk = [unicode(__script__ + ' V' + __version__, 'UTF-8')]
    LISTBOX = appuifw.Listbox(list_wk, do_dummy)
    appuifw.app.body = LISTBOX
    oldtitle = appuifw.app.title
    appuifw.app.title = unicode(__script__, "utf-8")
    appuifw.app.menu = [(unicode("開始","utf-8"), set_cfg_apid),
                        (unicode("終了","utf-8"), appExit) ]
    appuifw.app.exit_key_handler = lambda:appExit() #lock.signal()#do_dummy()
    e32.ao_yield() # 画面反映
    make_cfg_path()
    set_cfg_apid()
    lock.wait()
    appuifw.app.title = oldtitle


if __name__ == '__main__':
    main()

#    sys.exit()

